var aRuleGWList = [];

$(document).ready( function () {

	doGatewayFind(1);

	doRuleFind(1);
	
	replaceChecks();
	
});


function get_gateway_page(address,description,viewpage){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_gateway_page',
			address: address,
			description: description,
			viewpage: viewpage
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			if(data[0]['id'] != null){
			$.each(data, function (index, value) {
				addRowGateway("i",value);
			});
			}
			result = data;
		},
		error:function(){
			alert('error: get_gateway_page');
		}
	});
	
	return result;
}

function doGatewayFind(viewpage){
	var address = document.getElementById('eGatewayAddress').value;
	var description = document.getElementById('eGatewayDescription').value;

	var tab = $('table[id=GatewayTable]')[0];
	$(tab).find("tr:gt(0)").remove();
	var res = get_gateway_page(address,description,viewpage);

	// page numbers line
	var pagecount = res['0']['pagecount'];
	if(pagecount>0){
		var tab = $('table[id=GatewayTablePageLine]')[0];
		var td = $(tab).find("tr:eq(0)").children("td")[0];
		td.innerHTML = '';
		for (var i = 1; i <= pagecount; i++) {
			var active_num = (viewpage == i) ? 'border: 1px solid #7484a0; border-radius: 2px;' : '';
			td.innerHTML += '<input type="button" class="popup-pagenum" value="'+i+'" style="margin-left:1px;z-index: 99999;cursor:pointer;'+active_num+'" onclick="doGatewayFind('+i+');">';
		}
	}
	replaceChecks();
}

function onSaveClick(){

	$('tr[type=gateway_row]','table[id=GatewayTable]').each(function() { 
		
		var row_idx = $('td:eq(0)',this).text();
		var mode = $('td:eq(1)',this).text();
		
		if(mode == "a" || mode == "e"){
			//var id = Number($('td:eq(2)',this).text()) == NaN ? null : Number($('td:eq(2)',this).text());
			//var id = Number($('td:eq(2)',this).text());
			var id = $('td:eq(2)',this).text() == 'undefined' ? null : Number($('td:eq(2)',this).text());
			var gwid = $('td:eq(3)',this).text();
			var type = $('td:eq(4)',this).text();
			var address = $('td:eq(5)',this).text();
			var strip = $('td:eq(6)',this).text();
			var pri_prefix = $('td:eq(7)',this).text();
			var attrs = $('td:eq(8)',this).text();
			var probe_mode = $('td:eq(9)',this).text();
			var state = $('td:eq(10)',this).text();
			var socket = $('td:eq(11)',this).text();
			var description = $('td:eq(12)',this).text();
			//var state = $('input[id=ch_state_'+row_idx+']',this).attr('value');

			//alert(id,gwid,type,address,strip,pri_prefix,attrs,probe_mode,state,socket,description);
			save_gateway(id,gwid,type,address,strip,pri_prefix,attrs,probe_mode,state,socket,description);
		}

		if(mode == "d"){
			var id = Number($('td:eq(2)',this).text());
			del_gateway(id);
		}
		
	});


	$('tr[type=rule_row]','table[id=RuleTable]').each(function() { 
		
		var row_idx = $('td:eq(0)',this).text();
		var mode = $('td:eq(1)',this).text();
		
		if(mode == "a" || mode == "e"){
			//var id = Number($('td:eq(2)',this).text()) == NaN ? null : Number($('td:eq(2)',this).text());
			//var id = Number($('td:eq(2)',this).text());
			var ruleid = $('td:eq(2)',this).text() == 'undefined' ? null : Number($('td:eq(2)',this).text());
			var groupid = $('td:eq(3)',this).text();
			var prefix = $('td:eq(4)',this).text();
			var timerec = $('td:eq(5)',this).text();
			var priority = $('td:eq(6)',this).text();
			var routeid = $('td:eq(7)',this).text();
			var gwlist = $('td:eq(8)',this).text();
			var sort_alg = $('td:eq(9)',this).text();
			var sort_profile = $('td:eq(10)',this).text();
			var attrs = $('td:eq(11)',this).text();
			var description = $('td:eq(12)',this).text();

			//alert([ruleid,groupid,prefix,timerec,priority,routeid,gwlist,sort_alg,sort_profile,attrs,description]);
			save_rule(ruleid,groupid,prefix,timerec,priority,routeid,gwlist,sort_alg,sort_profile,attrs,description);
		}

		if(mode == "d"){
			var ruleid = Number($('td:eq(2)',this).text());
			del_rule(ruleid);
		}
		
	});
	

}

function save_gateway(id,gwid,type,address,strip,pri_prefix,attrs,probe_mode,state,socket,description){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_gateway',
			id: id,
			gwid: gwid,
			type: type,
			address: address,
			strip: strip,
			pri_prefix: pri_prefix,
			attrs: attrs,
			probe_mode: probe_mode,
			state: state,
			socket: socket,
			description: description
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: save_gateway');
		}
	});
}

function del_gateway(id){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'del_gateway',
			id: id
		}),
		dataType: 'json',
		async: false,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: del_gateway');
		}
	});
}


function save_rule(ruleid,groupid,prefix,timerec,priority,routeid,gwlist,sort_alg,sort_profile,attrs,description){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_rule',
			ruleid: ruleid,
			groupid: groupid,
			prefix: prefix,
			timerec: timerec,
			priority: priority,
			routeid: routeid,
			gwlist: gwlist,
			sort_alg: sort_alg,
			sort_profile: sort_profile,
			attrs: attrs,
			description: description
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: save_rule');
		}
	});
}

function del_rule(ruleid){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'del_rule',
			ruleid: ruleid
		}),
		dataType: 'json',
		async: false,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: del_rule');
		}
	});
}








function delGateway(obj){
	
	obj = obj.parentElement.parentElement;
	var row_idx = $("td:eq(0)", obj).text();
	var row_mode = $("td:eq(1)", obj).text();
	//alert(row_idx+' '+row_mode);
	
	if(row_mode == 'a') { 
		obj.remove(); 
	}
	else { 
		if(row_mode != 'd') { 
			$("td:eq(1)", obj).attr('row_mode','d'); 
			$("td:eq(1)", obj).text('d'); 
			$('td:visible',obj).attr('style','text-decoration:line-through;font-style:italic; color:#ff4444;');
			$(obj).children('td').css("backgroundColor","#f5f5f5");
		}
		else { 
			$("td:eq(1)", obj).attr('row_mode','e'); 
			$("td:eq(1)", obj).text('e'); 
			$('td:visible',obj).attr('style','text-decoration:none;font-style:normal; color:#777;');
			$(obj).children('td').css("backgroundColor","#ffc4c4");
		}
	}

}

function addRowGateway(mode,value){
	var tab = document.getElementById('GatewayTable');

	if(!value || value==null){
		value = {
			"id": "", 
			"gwid": "", 
			"type": "", 
			"address": "", 
			"strip": "", 
			"pri_prefix": "", 
			"attrs": "", 
			"probe_mode": "", 
			"state": "", 
			"socket": "",
			"description": ""
		};
	}
	//if( value["proxy_media"] != 1 ) value["proxy_media"] = 0;

	//var row_idx = $('tr[type=gateway_row]').length + 1;
	var row_mode = mode;
	var row_idx = 1;
	$('tr[type=gateway_row]').each(function() { 
		var idx = Number($('td:eq(0)',this).text()) + 1;
		if( idx > row_idx ) row_idx = idx;
	});

	document.getElementById('GatewayTableRecords').innerHTML = 'records: '+ row_idx;

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","Gateway_row");
	//tr.setAttribute("row_idx",row_idx);
	
	var td = document.createElement("td");
	td.setAttribute("row_idx",row_idx);
	td.style.display = "none";
	td.innerHTML =	row_idx;
	tr.appendChild(td);
	var td = document.createElement("td");
	td.setAttribute("row_mode",row_mode);
	td.style.display = "none";
	td.innerHTML =	row_mode;
	tr.appendChild(td);
	
	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["id"];
	tr.appendChild(td);


	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["gwid"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["type"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["address"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["strip"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["pri_prefix"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["attrs"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["probe_mode"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["state"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["socket"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["description"];
	tr.appendChild(td);



	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = "<img class=\"imglink\" style=\"display:inline;float:right;\" onclick=\"openGatewayModalForm(2,"+row_idx+");\" title=\"Edit Gateway\" src=\"../inc/img/edt.gif\">";
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = "<img class=\"imglink\" style=\"display:inline;float:right;\" onclick=\"delGateway(this);\" title=\"Delete Gateway\" src=\"../inc/img/del.gif\">";
	tr.appendChild(td);

	tab.appendChild(tr);

	tr.addEventListener('mouseover', function () {
        tr.style.backgroundColor='#D3D3D3';
    });
    tr.addEventListener('mouseleave', function () {
        tr.style.backgroundColor='#F5F5F5';
    });	

	if(mode == "a") $(tr).children('td').css("backgroundColor","#c4ffc4");
	
}

function doRowEdt(obj){
	
	var row = $(obj).parent().parent();
	if($("td:eq(1)", row).text() != "a") {
		$("td:eq(1)", row).text("e");
		$("td:eq(1)", row).attr("row_mode","e");
		$(row).children('td').css("backgroundColor","#ffc4c4");
	}

}


function openGatewayModalForm(mode, row_idx){
	
	document.getElementById('addGatewayForm').setAttribute('mode',mode);
	$('input[id^="GateForm_"]').val("");
	
	if(mode == 1){
	
		//checkSetValue('GateForm_state',0);
	
	}

	if(mode == 2){
		
		var tab = document.getElementById('GatewayTable');
		var row = $("tr",tab).eq(row_idx);
		$('input[id="GateForm_row_idx"]').val(row_idx);

		var cell = $("td:eq(2)", row).text();
		document.getElementById('GateForm_id').value = cell;

		var cell = $("td:eq(3)", row).text();
		document.getElementById('GateForm_gwid').value = cell;

		var cell = $("td:eq(4)", row).text();
		document.getElementById('GateForm_type').value = cell;

		var cell = $("td:eq(5)", row).text();
		document.getElementById('GateForm_address').value = cell;

		var cell = $("td:eq(6)", row).text();
		document.getElementById('GateForm_strip').value = cell;

		var cell = $("td:eq(7)", row).text();
		document.getElementById('GateForm_pri_prefix').value = cell;

		var cell = $("td:eq(8)", row).text();
		document.getElementById('GateForm_attrs').value = cell;

		var cell = $("td:eq(9)", row).text();
		document.getElementById('GateForm_probe_mode').value = cell;

		var cell = $("td:eq(10)", row).text();
		document.getElementById('GateForm_state').value = cell;

		var cell = $("td:eq(11)", row).text();
		document.getElementById('GateForm_socket').value = cell;

		var cell = $("td:eq(12)", row).text();
		document.getElementById('GateForm_description').value = cell;

	}
	
	$('#addGatewayForm').arcticmodal();
}


function addGateway(){
	var tab = document.getElementById('GatewayTable');
	var mode = document.getElementById('addGatewayForm').getAttribute('mode');

	var value = {
		"gwid": document.getElementById('GateForm_gwid').value, 
		"type": document.getElementById('GateForm_type').value, 
		"address": document.getElementById('GateForm_address').value, 
		"strip": document.getElementById('GateForm_strip').value, 
		"pri_prefix": document.getElementById('GateForm_pri_prefix').value, 
		"attrs": document.getElementById('GateForm_attrs').value, 
		"probe_mode": document.getElementById('GateForm_probe_mode').value, 
		"state": document.getElementById('GateForm_state').value, 
		"socket": document.getElementById('GateForm_socket').value, 
		"description": document.getElementById('GateForm_description').value
	};

	if(mode == 1){ // add
		addRowGateway("a",value);
	}
	if(mode == 2){ // edt
		var row_idx = $('input[id="GateForm_row_idx"]').val();
		edtRowGateway(row_idx,value);
	}
	
	$('#addGatewayForm').arcticmodal('close');
	replaceChecks();
}

function edtRowGateway(row_idx,value){
		var tab = document.getElementById('GatewayTable');
		var row = $("tr",tab).eq(row_idx);

		if($("td:eq(1)", row).text() != "a") $("td:eq(1)", row).text("e");
		//$("td:eq(2)", row).text(value['id']);

		$("td:eq(3)", row).text(value['gwid']);
		$("td:eq(4)", row).text(value['type']);
		$("td:eq(5)", row).text(value['address']);
		$("td:eq(6)", row).text(value['strip']);
		$("td:eq(7)", row).text(value['pri_prefix']);
		$("td:eq(8)", row).text(value['attrs']);
		$("td:eq(9)", row).text(value['probe_mode']);
		$("td:eq(10)", row).text(value['state']);
		$("td:eq(11)", row).text(value['socket']);
		$("td:eq(12)", row).text(value['description']);
		//checkSetValue('ch_state_'+row_idx,value['state']);
		
		if($("td:eq(1)", row).text() != "a") $(row).children('td').css("backgroundColor","#ffc4c4");
}




//------------------------------------------------------------------------------------------------------------
// rules
//------------------------------------------------------------------------------------------------------------

function get_gwrule_page(gwlist,description,viewpage){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_gwrule_page',
			gwlist: gwlist,
			description: description,
			viewpage: viewpage
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			if(data[0]['ruleid'] != null){
			$.each(data, function (index, value) {
				addRowRule("i",value);
				//alert(value['description'])
			});
			}
			result = data;
		},
		error:function(){
			alert('error: get_gwrule_page');
		}
	});
	
	return result;
}

function doRuleFind(viewpage){
	var gwlist = document.getElementById('eRuleGWList').value;
	var description = document.getElementById('eRuleDescription').value;

	var tab = $('table[id=RuleTable]')[0];
	$(tab).find("tr:gt(0)").remove();
	var res = get_gwrule_page(gwlist,description,viewpage);

	// page numbers line
	var pagecount = res['0']['pagecount'];
	if(pagecount>0){
		var tab = $('table[id=RuleTablePageLine]')[0];
		var td = $(tab).find("tr:eq(0)").children("td")[0];
		td.innerHTML = '';
		for (var i = 1; i <= pagecount; i++) {
			var active_num = (viewpage == i) ? 'border: 1px solid #7484a0; border-radius: 2px;' : '';
			td.innerHTML += '<input type="button" class="popup-pagenum" value="'+i+'" style="margin-left:1px;z-index: 99999;cursor:pointer;'+active_num+'" onclick="doRuleFind('+i+');">';
		}
	}
	replaceChecks();
}

function delRule(obj){
	
	obj = obj.parentElement.parentElement;
	var row_idx = $("td:eq(0)", obj).text();
	var row_mode = $("td:eq(1)", obj).text();
	//alert(row_idx+' '+row_mode);
	
	if(row_mode == 'a') { 
		obj.remove(); 
	}
	else { 
		if(row_mode != 'd') { 
			$("td:eq(1)", obj).attr('row_mode','d'); 
			$("td:eq(1)", obj).text('d'); 
			$('td:visible',obj).attr('style','text-decoration:line-through;font-style:italic; color:#ff4444;');
			$(obj).children('td').css("backgroundColor","#f5f5f5");
		}
		else { 
			$("td:eq(1)", obj).attr('row_mode','e'); 
			$("td:eq(1)", obj).text('e'); 
			$('td:visible',obj).attr('style','text-decoration:none;font-style:normal; color:#777;');
			$(obj).children('td').css("backgroundColor","#ffc4c4");
		}
	}

}

function addRowRule(mode,value){
	var tab = document.getElementById('RuleTable');

	if(!value || value==null){
		value = {
			"ruleid": "",
			"groupid": "",
			"prefix": "",
			"timerec": "",
			"priority": "",
			"routeid": "",
			"gwlist": "",
			"sort_alg": "",
			"sort_profile": "",
			"attrs": "",
			"description": "",
		};
	}

	//var row_idx = $('tr[type=rule_row]').length + 1;
	var row_mode = mode;
	var row_idx = 1;
	$('tr[type=rule_row]').each(function() { 
		var idx = Number($('td:eq(0)',this).text()) + 1;
		if( idx > row_idx ) row_idx = idx;
	});

	document.getElementById('RuleTableRecords').innerHTML = 'records: '+ row_idx;

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","Rule_row");
	//tr.setAttribute("row_idx",row_idx);
	
	var td = document.createElement("td");
	td.setAttribute("row_idx",row_idx);
	td.style.display = "none";
	td.innerHTML =	row_idx;
	tr.appendChild(td);
	var td = document.createElement("td");
	td.setAttribute("row_mode",row_mode);
	td.style.display = "none";
	td.innerHTML =	row_mode;
	tr.appendChild(td);
	
	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["ruleid"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["groupid"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["prefix"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["timerec"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["priority"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["routeid"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["gwlist"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["sort_alg"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["sort_profile"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["attrs"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["description"];
	tr.appendChild(td);


	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = "<img class=\"imglink\" style=\"display:inline;float:right;\" onclick=\"openRuleModalForm(2,"+row_idx+");\" title=\"Edit Rule\" src=\"../inc/img/edt.gif\">";
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = "<img class=\"imglink\" style=\"display:inline;float:right;\" onclick=\"delRule(this);\" title=\"Delete Rule\" src=\"../inc/img/del.gif\">";
	tr.appendChild(td);

	tab.appendChild(tr);

	tr.addEventListener('mouseover', function () {
        tr.style.backgroundColor='#D3D3D3';
    });
    tr.addEventListener('mouseleave', function () {
        tr.style.backgroundColor='#F5F5F5';
    });	

	if(mode == "a") $(tr).children('td').css("backgroundColor","#c4ffc4");
	
}


function openRuleModalForm(mode, row_idx){
	
	document.getElementById('addRuleForm').setAttribute('mode',mode);
	$('input[id^="RuleForm_"]').val("");
	
	if(mode == 1){
	
		//checkSetValue('GateForm_state',0);
	
	}

	if(mode == 2){
		//alert(row_idx);
		var tab = document.getElementById('RuleTable');
		var row = $("tr",tab).eq(row_idx);
		$('input[id="RuleForm_row_idx"]').val(row_idx);

		var cell = $("td:eq(2)", row).text();
		document.getElementById('RuleForm_ruleid').value = cell;

		var cell = $("td:eq(3)", row).text();
		document.getElementById('RuleForm_groupid').value = cell;

		var cell = $("td:eq(4)", row).text();
		document.getElementById('RuleForm_prefix').value = cell;

		var cell = $("td:eq(5)", row).text();
		document.getElementById('RuleForm_timerec').value = cell;

		var cell = $("td:eq(6)", row).text();
		document.getElementById('RuleForm_priority').value = cell;

		var cell = $("td:eq(7)", row).text();
		document.getElementById('RuleForm_routeid').value = cell;

		var cell = $("td:eq(8)", row).text();
		document.getElementById('RuleForm_gwlist').value = cell;

		var cell = $("td:eq(9)", row).text();
		document.getElementById('RuleForm_sort_alg').value = cell;

		var cell = $("td:eq(10)", row).text();
		document.getElementById('RuleForm_sort_profile').value = cell;

		var cell = $("td:eq(11)", row).text();
		document.getElementById('RuleForm_attrs').value = cell;

		var cell = $("td:eq(12)", row).text();
		document.getElementById('RuleForm_description').value = cell;
			
	}
	
	$('#addRuleForm').arcticmodal();
}

function addRule(){
	var tab = document.getElementById('RuleTable');
	var mode = document.getElementById('addRuleForm').getAttribute('mode');
	//alert(mode);

	var value = {
		"ruleid": document.getElementById('RuleForm_ruleid').value, 
		"groupid": document.getElementById('RuleForm_groupid').value, 
		"prefix": document.getElementById('RuleForm_prefix').value, 
		"timerec": document.getElementById('RuleForm_timerec').value, 
		"priority": document.getElementById('RuleForm_priority').value, 
		"routeid": document.getElementById('RuleForm_routeid').value, 
		"gwlist": document.getElementById('RuleForm_gwlist').value, 
		"sort_alg": document.getElementById('RuleForm_sort_alg').value, 
		"sort_profile": document.getElementById('RuleForm_sort_profile').value, 
		"attrs": document.getElementById('RuleForm_attrs').value, 
		"description": document.getElementById('RuleForm_description').value
	};

	if(mode == 1){ // add
		addRowRule("a",value);
	}
	if(mode == 2){ // edt
		var row_idx = $('input[id="RuleForm_row_idx"]').val();
		edtRowRule(row_idx,value);
	}
	
	$('#addRuleForm').arcticmodal('close');
	replaceChecks();
}

function edtRowRule(row_idx,value){
		var tab = document.getElementById('RuleTable');
		var row = $("tr",tab).eq(row_idx);

		if($("td:eq(1)", row).text() != "a") $("td:eq(1)", row).text("e");

		$("td:eq(2)", row).text(value['ruleid']);
		$("td:eq(3)", row).text(value['groupid']);
		$("td:eq(4)", row).text(value['prefix']);
		$("td:eq(5)", row).text(value['timerec']);
		$("td:eq(6)", row).text(value['priority']);
		$("td:eq(7)", row).text(value['routeid']);
		$("td:eq(8)", row).text(value['gwlist']);
		$("td:eq(9)", row).text(value['sort_alg']);
		$("td:eq(10)", row).text(value['sort_profile']);
		$("td:eq(11)", row).text(value['attrs']);
		$("td:eq(12)", row).text(value['description']);
		
		if($("td:eq(1)", row).text() != "a") $(row).children('td').css("backgroundColor","#ffc4c4");
}

function doGateway_Reset(){
	document.getElementById('eGatewayAddress').value = '';
	document.getElementById('eGatewayDescription').value = '';
	doGatewayFind(1);
}
function doRule_Reset(){
	document.getElementById('eRuleGWList').value = '';
	document.getElementById('eRuleDescription').value = '';
	doRuleFind(1);
}


function openSelectGatewayModalForm(){
	
	var str_gwid = document.getElementById('RuleForm_gwlist').value;
	str_gwid.replace(' ','');
	aRuleGWList = [];
	aRuleGWList = str_gwid.split(',');
	//alert(aRuleGWList);
	
	doSelectGatewayFind(1);

	$('#selectGatewayForm').arcticmodal();
}

function get_select_gateway_page(address,description,viewpage){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_select_gateway_page',
			address: address,
			description: description,
			viewpage: viewpage
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			if(data[0]['id'] != null){
			$.each(data, function (index, value) {
				addRowSelectGateway("i",value);
			});
			}
			result = data;
		},
		error:function(){
			alert('error: get_select_gateway_page');
		}
	});
	
	return result;
}

function doSelectGatewayFind(viewpage){

	//var address = document.getElementById('eSelectGatewayAddress').value;
	//var description = document.getElementById('eSelectGatewayDescription').value;

	var tab = $('table[id=SelectGatewayTable]')[0];
	$(tab).find("tr:gt(0)").remove();
	//$(tab).find("tr").remove();
	//var res = get_select_gateway_page(address,description,viewpage);
	var res = get_select_gateway_page(null,null,viewpage);

	// page numbers line
	var pagecount = res['0']['pagecount'];
	if(pagecount>0){
		var tab = $('table[id=SelectGatewayTablePageLine]')[0];
		var td = $(tab).find("tr:eq(0)").children("td")[0];
		td.innerHTML = '';
		for (var i = 1; i <= pagecount; i++) {
			var active_num = (viewpage == i) ? 'border: 1px solid #7484a0; border-radius: 2px;' : '';
			td.innerHTML += '<input type="button" class="popup-pagenum" value="'+i+'" style="margin-left:1px;z-index: 99999;cursor:pointer;'+active_num+'" onclick="doSelectGatewayFind('+i+');">';
		}
	}
	replaceChecks();
}



function addRowSelectGateway(mode,value){
	var tab = document.getElementById('SelectGatewayTable');

	if(!value || value==null){
		value = {
			"id": "", 
			"gwid": "", 
			"type": "", 
			"address": "", 
			"strip": "", 
			"pri_prefix": "", 
			"attrs": "", 
			"probe_mode": "", 
			"state": "", 
			"socket": "",
			"description": ""
		};
	}
	//if( value["proxy_media"] != 1 ) value["proxy_media"] = 0;

	//var row_idx = $('tr[type=gateway_row]').length + 1;
	var row_mode = mode;
	var row_idx = 1;
	$('tr[type=select_gateway_row]').each(function() { 
		var idx = Number($('td:eq(0)',this).text()) + 1;
		if( idx > row_idx ) row_idx = idx;
	});

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","select_gateway_row");
	
	var td = document.createElement("td");
	td.setAttribute("row_idx",row_idx);
	td.style.display = "none";
	td.innerHTML =	row_idx;
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["gwid"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.width = "40px";
	td.style="padding-left:10px;";
	//if( value["state"] == 1 ) chkey = "checked"; else chkey = "";
	if( $.inArray(value["gwid"],aRuleGWList)==-1 ) {chkey = "";chval='0';} else {chkey = "checked";chval='1';}
	//alert(chkey);
	td.innerHTML = "<input type=\"checkbox\" class=\"selectw\" " +
		"name=\"gw_select_"+row_idx+"\" " +
		"id=\"gw_select_"+row_idx+"\" " +
		//"value=\""+value["state"]+"\" " +
		"value=\""+chval+"\" " +
		chkey+
		" onchange=\"doSelectGatewayRowEdt(this);\" "+
		"/>";	
	tr.appendChild(td);	


	tab.appendChild(tr);

	//tr.addEventListener('mouseover', function () {
    //    tr.style.backgroundColor='#D3D3D3';
    //});
    //tr.addEventListener('mouseleave', function () {
    //    tr.style.backgroundColor='#F5F5F5';
    //});	
	
}

function doSelectGatewayRowEdt(obj){
	var row = $(obj).parent().parent();
	var gwname = $("td:eq(1)", row).text();
	if(obj.checked) {
		aRuleGWList.push( gwname );
	} else {
		var key = $.inArray(gwname,aRuleGWList);
		aRuleGWList.splice(key, 1);
	}
}

function addSelectGateway(){
	//alert(aRuleGWList);
	var gwid = document.getElementById('RuleForm_gwlist');
	gwid.value = aRuleGWList.join(',');
	$('#selectGatewayForm').arcticmodal('close');
}