
$(document).ready( function () {

	doRegistrantFind(1);

	replaceChecks();
	
});


function get_registrant_page(username,registrar,viewpage){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_registrant_page',
			username,
			registrar,
			viewpage: viewpage
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			if(data[0]['id'] != null){
			$.each(data, function (index, value) {
				addRowRegistrant("i",value);
			});
			}
			result = data;
		},
		error:function(){
			alert('error: get_registrant_page');
		}
	});
	
	return result;
}

function doRegistrantFind(viewpage){
	var username = document.getElementById('eRegistrantUsername').value;
	var registrar = document.getElementById('eRegistrantRegistrar').value;

	var tab = $('table[id=RegistrantTable]')[0];
	$(tab).find("tr:gt(0)").remove();
	var res = get_registrant_page(username,registrar,viewpage);

	// page numbers line
	var pagecount = res['0']['pagecount'];
	if(pagecount>0){
		var tab = $('table[id=RegistrantTablePageLine]')[0];
		var td = $(tab).find("tr:eq(0)").children("td")[0];
		td.innerHTML = '';
		for (var i = 1; i <= pagecount; i++) {
			var active_num = (viewpage == i) ? 'border: 1px solid #7484a0; border-radius: 2px;' : '';
			td.innerHTML += '<input type="button" class="popup-pagenum" value="'+i+'" style="margin-left:1px;z-index: 99999;cursor:pointer;'+active_num+'" onclick="doRegistrantFind('+i+');">';
		}
	}
	replaceChecks();
}

function onSaveClick(){

	$('tr[type=registrant_row]','table[id=RegistrantTable]').each(function() { 
		
		var row_idx = $('td:eq(0)',this).text();
		var mode = $('td:eq(1)',this).text();
		
		if(mode == "a" || mode == "e"){
			//var id = Number($('td:eq(2)',this).text()) == NaN ? null : Number($('td:eq(2)',this).text());
			//var id = Number($('td:eq(2)',this).text());
			var id = $('td:eq(2)',this).text() == 'undefined' ? null : Number($('td:eq(2)',this).text());
			var registrar = $('td:eq(4)',this).text();
			var proxy = $('td:eq(5)',this).text();
			var aor = $('td:eq(6)',this).text();
			var third_party_registrant = $('td:eq(7)',this).text();
			var username = $('td:eq(8)',this).text();
			var password = $('td:eq(3)',this).text();
			var binding_uri = $('td:eq(9)',this).text();
			var binding_params = $('td:eq(10)',this).text();
			var expiry = $('td:eq(11)',this).text();
			var forced_socket = $('td:eq(12)',this).text();
			var cluster_shtag = $('td:eq(13)',this).text();
			//var proxy_media = $('td:eq(9)',this).attr('val');
			var state = $('input[id=ch_state_'+row_idx+']',this).attr('value');


			//alert(id+' '+registrar+' '+proxy+' '+aor+' '+third_party_registrant+' '+username+' '+password+' '+binding_uri+' '+binding_params+' '+expiry+' '+forced_socket+' '+cluster_shtag+' '+state);
			save_registrant(id,registrar,proxy,aor,third_party_registrant,username,password,binding_uri,binding_params,expiry,forced_socket,cluster_shtag,state);
		}

		if(mode == "d"){
			var id = Number($('td:eq(2)',this).text());
			del_registrant(id);
		}
		
	});

}

function save_registrant(id,registrar,proxy,aor,third_party_registrant,username,password,binding_uri,binding_params,expiry,forced_socket,cluster_shtag,state){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_registrant',
			id: id,
			registrar: registrar,
			proxy: proxy,
			aor: aor,
			third_party_registrant: third_party_registrant,
			username: username,
			password: password,
			binding_uri: binding_uri,
			binding_params: binding_params,
			expiry: expiry,
			forced_socket: forced_socket,
			cluster_shtag: cluster_shtag,
			state: state
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: save_registrant');
		}
	});
}

function del_registrant(id){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'del_registrant',
			id: id
		}),
		dataType: 'json',
		async: false,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: del_registrant');
		}
	});
}


function delRegistrant(obj){
	
	obj = obj.parentElement.parentElement;
	var row_idx = $("td:eq(0)", obj).text();
	var row_mode = $("td:eq(1)", obj).text();
	//alert(row_idx+' '+row_mode);
	
	if(row_mode == 'a') { 
		obj.remove(); 
	}
	else { 
		if(row_mode != 'd') { 
			$("td:eq(1)", obj).attr('row_mode','d'); 
			$("td:eq(1)", obj).text('d'); 
			$('td:visible',obj).attr('style','text-decoration:line-through;font-style:italic; color:#ff4444;');
			$(obj).children('td').css("backgroundColor","#f5f5f5");
		}
		else { 
			$("td:eq(1)", obj).attr('row_mode','e'); 
			$("td:eq(1)", obj).text('e'); 
			$('td:visible',obj).attr('style','text-decoration:none;font-style:normal; color:#777;');
			$(obj).children('td').css("backgroundColor","#ffc4c4");
		}
	}

}

function addRowRegistrant(mode,value){
	var tab = document.getElementById('RegistrantTable');

	if(!value || value==null){
		value = {
			"id": "", 
			"registrar": "", 
			"proxy": "", 
			"aor": "", 
			"third_party_registrant": "", 
			"username": "", 
			"password": "", 
			"binding_uri": "", 
			"binding_params": "", 
			"expiry": "", 
			"forced_socket": "", 
			"cluster_shtag": "", 
			"state": ""
		};
	}
	if( value["proxy_media"] != 1 ) value["proxy_media"] = 0;

	//var row_idx = $('tr[type=registrant_row]').length + 1;
	var row_mode = mode;
	var row_idx = 1;
	$('tr[type=registrant_row]').each(function() { 
		var idx = Number($('td:eq(0)',this).text()) + 1;
		if( idx > row_idx ) row_idx = idx;
	});

	document.getElementById('RegistrantTableRecords').innerHTML = 'records: '+ row_idx;

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","registrant_row");
	//tr.setAttribute("row_idx",row_idx);

	//<!-- 0 -->
	var td = document.createElement("td");
	td.setAttribute("row_idx",row_idx);
	td.style.display = "none";
	td.innerHTML =	row_idx;
	tr.appendChild(td);
	var td = document.createElement("td");
	td.setAttribute("row_mode",row_mode);
	td.style.display = "none";
	td.innerHTML =	row_mode;
	tr.appendChild(td);
	
	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["id"];
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["password"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["registrar"];
	tr.appendChild(td);





	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["proxy"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["aor"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["third_party_registrant"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["username"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["binding_uri"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["binding_params"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["expiry"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["forced_socket"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["cluster_shtag"];
	tr.appendChild(td);

	//var td = document.createElement("td");
	//td.className = "infoTableCell";
	//td.innerHTML = value["state"];
	//tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.width = "40px";
	td.style="padding-left:10px;";
	if( value["state"] == 1 ) chkey = "checked"; else chkey = "";
	//alert(chkey);
	td.innerHTML = "<input type=\"checkbox\" class=\"selectw\" " +
		"name=\"ch_state_"+row_idx+"\" " +
		"id=\"ch_state_"+row_idx+"\" " +
		"value=\""+value["state"]+"\" " +
		chkey+
		" onchange=\"doRowEdt(this);\" "+
		"/>";	
	tr.appendChild(td);	

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = "<img class=\"imglink\" style=\"display:inline;float:right;\" onclick=\"openRegistrantModalForm(2,"+row_idx+");\" title=\"Edit Registrant\" src=\"../inc/img/edt.gif\">";
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = "<img class=\"imglink\" style=\"display:inline;float:right;\" onclick=\"delRegistrant(this);\" title=\"Delete Registrant\" src=\"../inc/img/del.gif\">";
	tr.appendChild(td);

	tab.appendChild(tr);

	tr.addEventListener('mouseover', function () {
        tr.style.backgroundColor='#D3D3D3';
    });
    tr.addEventListener('mouseleave', function () {
        tr.style.backgroundColor='#F5F5F5';
    });	

	if(mode == "a") $(tr).children('td').css("backgroundColor","#c4ffc4");
	
}

function doRowEdt(obj){
	
	var row = $(obj).parent().parent();
	if($("td:eq(1)", row).text() != "a") {
		$("td:eq(1)", row).text("e");
		$("td:eq(1)", row).attr("row_mode","e");
		$(row).children('td').css("backgroundColor","#ffc4c4");
	}

}


function openRegistrantModalForm(mode, row_idx){
	
	document.getElementById('addRegistrantForm').setAttribute('mode',mode);
	$('input[id^="RegForm_"]').val("");
	
	if(mode == 1){
	
		checkSetValue('RegForm_state',0);
	
	}

	if(mode == 2){
		
		var tab = document.getElementById('RegistrantTable');
		var row = $("tr",tab).eq(row_idx);
		$('input[id="RegForm_row_idx"]').val(row_idx);

		var cell = $("td:eq(2)", row).text();
		document.getElementById('RegForm_id').value = cell;

		var cell = $("td:eq(4)", row).text();
		document.getElementById('RegForm_registrar').value = cell;

		var cell = $("td:eq(5)", row).text();
		document.getElementById('RegForm_proxy').value = cell;

		var cell = $("td:eq(6)", row).text();
		document.getElementById('RegForm_aor').value = cell;

		var cell = $("td:eq(7)", row).text();
		document.getElementById('RegForm_third_party_registrant').value = cell;

		var cell = $("td:eq(8)", row).text();
		document.getElementById('RegForm_username').value = cell;

		var cell = $("td:eq(9)", row).text();
		document.getElementById('RegForm_binding_uri').value = cell;

		var cell = $("td:eq(10)", row).text();
		document.getElementById('RegForm_binding_params').value = cell;

		var cell = $("td:eq(11)", row).text();
		document.getElementById('RegForm_expiry').value = cell;

		var cell = $("td:eq(12)", row).text();
		document.getElementById('RegForm_forced_socket').value = cell;

		var cell = $("td:eq(13)", row).text();
		document.getElementById('RegForm_cluster_shtag').value = cell;
		
		var cell = $('input[id=ch_state_'+row_idx+']',row).attr('value');
		checkSetValue('RegForm_state',cell);

	}
	
	$('#addRegistrantForm').arcticmodal();
}


function addRegistrant(){
	var tab = document.getElementById('RegistrantTable');
	var mode = document.getElementById('addRegistrantForm').getAttribute('mode');

	var value = {
		"registrar": document.getElementById('RegForm_registrar').value, 
		"proxy": document.getElementById('RegForm_proxy').value, 
		"aor": document.getElementById('RegForm_aor').value, 
		"third_party_registrant": document.getElementById('RegForm_third_party_registrant').value, 
		"username": document.getElementById('RegForm_username').value, 
		"password": document.getElementById('RegForm_password').value, 
		"binding_uri": document.getElementById('RegForm_binding_uri').value, 
		"binding_params": document.getElementById('RegForm_binding_params').value, 
		"expiry": document.getElementById('RegForm_expiry').value, 
		"forced_socket": document.getElementById('RegForm_forced_socket').value, 
		"cluster_shtag": document.getElementById('RegForm_cluster_shtag').value, 
		"state": document.getElementById('RegForm_state').value
	};

	if(mode == 1){ // add
		addRowRegistrant("a",value);
	}
	if(mode == 2){ // edt
		var row_idx = $('input[id="RegForm_row_idx"]').val();
		edtRowRegistrant(row_idx,value);
	}
	
	$('#addRegistrantForm').arcticmodal('close');
	replaceChecks();
}

function edtRowRegistrant(row_idx,value){
		var tab = document.getElementById('RegistrantTable');
		var row = $("tr",tab).eq(row_idx);

		if($("td:eq(1)", row).text() != "a") $("td:eq(1)", row).text("e");
		//$("td:eq(2)", row).text(value['id']);

		$("td:eq(4)", row).text(value['registrar']);
		$("td:eq(5)", row).text(value['proxy']);
		$("td:eq(6)", row).text(value['aor']);
		$("td:eq(7)", row).text(value['third_party_registrant']);
		$("td:eq(8)", row).text(value['username']);
		$("td:eq(3)", row).text(value['password']);
		$("td:eq(9)", row).text(value['binding_uri']);
		$("td:eq(10)", row).text(value['binding_params']);
		$("td:eq(11)", row).text(value['expiry']);
		$("td:eq(12)", row).text(value['forced_socket']);
		$("td:eq(13)", row).text(value['cluster_shtag']);
		checkSetValue('ch_state_'+row_idx,value['state']);
		
		if($("td:eq(1)", row).text() != "a") $(row).children('td').css("backgroundColor","#ffc4c4");
}

