<?php
require_once('../com/htmlcode.php');
require_once('../com/database.php');
require_once('../com/session.php');


if($session->logged_in) {
?>

<!doctype html>
<html>
<head>
<?php require_once('../inc/common_htmlhead.inc'); ?>
<script language="javascript" type="text/JavaScript" src="../script/reg.js"></script>
<script language="javascript" type="text/JavaScript" src="../script/loadcdr.js"></script>


	<script src="../lib/jquery_plugin/arcticmodal/jquery.arcticmodal.js"></script>
	<link rel="stylesheet" href="../lib/jquery_plugin/arcticmodal/jquery.arcticmodal.css">
	<!--link rel="stylesheet" href="../lib/jquery_plugin/arcticmodal/themes/simple.css"-->
	<link rel="stylesheet" href="../lib/jquery_plugin/arcticmodal/themes/grey.css">
	
</head>

<body id="page-main">
<?php require_once('../inc/common_header.inc'); ?>


<form name="mainform">
			
	<!-- CDR ACC -->
	<fieldset class="fieldset-sector" style="width:98%;">
	<!-- legend class="legend-sector" style="cursor:pointer;" onclick="openCDRModalForm(1);">CDR <img src="../inc/img/add.gif" style="vertical-align:middle;cursor:pointer;" title="Add CDR"></legend -->
	<legend class="legend-sector" style="cursor:pointer;" >CDR accounted calls</legend>


	<!-- Filter -->
	<fieldset class="fieldset-filter">

	<table class="tnp" style="width:100%; margin-top: 10px;">

	<tr>
	<td>Created </td><td><input type="text" id="f_ACC_created_D1" class="selectw90"></td>
	<td><input type="text" id="f_ACC_created_T1" class="24h selectw90"></td>
	<td> - </td><td><input type="text" id="f_ACC_created_D2" class="selectw90"></td>
	<td><input type="text" id="f_ACC_created_T2" class="24h selectw90"></td>
	<td style="width:70%;"></td>
	</tr>

	</table>

	<table class="tnp" style="width:100%;">
	<tr>
	<td class="editLineParam" style="width:0;">Method</td>
	<td class="editLineValue"><input id="f_CDR_ACC_method" type="text" class="selectw120"/></td>
	<td style="width:100%;"></td>
	</tr>
	</table>

	<table class="tnp" style="width:100%;">
	<tr>
	<td><button class="roundbtn" onclick="doCDR_ACC_Reset(); return false;">Reset&nbsp;<img src="../inc/img/reset.png" style="margin-top:0;padding-left:6px;"></button></td>
	<td class="editLineParam">&nbsp;</td>
	<td class="editLineParam">&nbsp;</td>

	<td nowrap style="text-align:right;">rec/page
	<select id="f_ACC_recpage" class="selectw50" style="vertical-align:top;"><option>20</option><option>40</option><option>60</option><option>80</option><option>100</option></select>
	<button class="roundbtn" onclick="doCDR_ACC_Find(1); return false;">Find&nbsp;<img src="../inc/img/loupe.png" style="margin-top:0;padding-left:6px;"></button>
	</td>
	
	</tr>
	</table>
	
	</fieldset>
	
	<!-- CDR ACC Table -->
	<div id="CDR_ACC_TableRecords" style="width:100%;text-align:right;color:#777;">records: 0</div>
	
	<table id="CDR_ACC_Table" class="tsp" style="width:100%">
	<tr class="editTableHeader">

		<td style="display:none">row_idx</td>
		<td style="display:none">row_mode</td>
		<td style="display:none">id</td>

		<td class="infoTableHeader">method</td>
		<td class="infoTableHeader" style="display:none">from_tag</td>
		<td class="infoTableHeader" style="display:none">to_tag</td>
		<td class="infoTableHeader" style="display:none">callid</td>
		<td class="infoTableHeader">sip_code</td>
		<td class="infoTableHeader">sip_reason</td>
		<td class="infoTableHeader" style="display:none">time_cmpl</td>
		<td class="infoTableHeader">duration</td>
		<td class="infoTableHeader">ms_duration</td>
		<td class="infoTableHeader">setuptime</td>
		<td class="infoTableHeader">created</td>
		<td class="infoTableHeader" style="display:none">src_ip</td>
		<td class="infoTableHeader" style="display:none">dst_ip</td>
		<td class="infoTableHeader">peer_name</td>
		<td class="infoTableHeader">dest_name</td>
		<td class="infoTableHeader" style="display:none">dest_addr</td>

		<td>&nbsp;</td>
		<td>&nbsp;</td>

	</tr>
	</table>
	
		<div> <table id="CDR_ACC_TablePageLine"> <tr><td></td></tr> </table> </div>
	
	</fieldset>


	<!-- CDR MISSED_CALLS -->
	<fieldset class="fieldset-sector" style="width:98%;">
	<legend class="legend-sector" style="cursor:pointer;" >CDR missed calls</legend>

	<!-- Filter -->
	<fieldset class="fieldset-filter">
	
	<table class="tnp" style="width:100%; margin-top: 10px;">
	<tr>
	<td>Created </td><td><input type="text" id="f_MC_created_D1" class="selectw90"></td>
	<td><input type="text" id="f_MC_created_T1" class="24h selectw90"></td>
	<td> - </td><td><input type="text" id="f_MC_created_D2" class="selectw90"></td>
	<td><input type="text" id="f_MC_created_T2" class="24h selectw90"></td>
	<td style="width:70%;"></td>
	</tr>
	</table>
	
	<table class="tnp" style="width:100%;">
	<tr>
	<td class="editLineParam" style="width:0;">Method</td>
	<td class="editLineValue"><input id="f_CDR_MC_method" type="text" class="selectw120"/></td>
	<td style="width:100%;"></td>
	</tr>
	</table>

	<table class="tnp" style="width:100%;">
	<tr>
	<td><button class="roundbtn" onclick="doCDR_MC_Reset(); return false;">Reset&nbsp;<img src="../inc/img/reset.png" style="margin-top:0;padding-left:6px;"></button></td>
	<td class="editLineParam">&nbsp;</td>
	<td class="editLineParam">&nbsp;</td>
	<td style="text-align:right;">rec/page
	<select id="f_MC_recpage" class="selectw50" style="vertical-align:top;"><option>20</option><option>40</option><option>60</option><option>80</option><option>100</option></select>
	<button class="roundbtn" onclick="doCDR_MC_Find(1); return false;">Find&nbsp;<img src="../inc/img/loupe.png" style="margin-top:0;padding-left:6px;"></button>
	</td>
	</tr>
	</table>

	</fieldset>
	
	<!-- CDR MISSED_CALLS Table -->
	<div id="CDR_MC_TableRecords" style="width:100%;text-align:right;color:#777;">records: 0</div>
	
	<table id="CDR_MC_Table" class="nb" style="width:100%">
	<tr class="editTableHeader">

		<td style="display:none">row_idx</td>
		<td style="display:none">row_mode</td>
		<td style="display:none">id</td>

		<td class="infoTableHeader">method</td>
		<td class="infoTableHeader" style="display:none">from_tag</td>
		<td class="infoTableHeader" style="display:none">to_tag</td>
		<td class="infoTableHeader" style="display:none">callid</td>
		<td class="infoTableHeader">sip_code</td>
		<td class="infoTableHeader">sip_reason</td>
		<td class="infoTableHeader" style="display:none">time_cmpl</td>
		<td class="infoTableHeader">setuptime</td>
		<td class="infoTableHeader">created</td>
		<td class="infoTableHeader" style="display:none">src_ip</td>
		<td class="infoTableHeader" style="display:none">dst_ip</td>
		<td class="infoTableHeader">peer_name</td>
		<td class="infoTableHeader">dest_name</td>
		<td class="infoTableHeader" style="display:none">dest_addr</td>

		<td>&nbsp;</td>
		<td>&nbsp;</td>

	</tr>
	</table>

		<div> <table id="CDR_MC_TablePageLine"> <tr><td></td></tr> </table> </div>
	
	</fieldset>




<!-- CDR_ACC_Table_Form ---------------------------------------------------------------------------------- -->

	<div class="g-hidden">
	<div class="box-modal" id="CDR_ACC_Table_Form" mode="0">
		<div class="box-modal_name">ACC</div>
		<div class="box-modal_close arcticmodal-close">close</div>
		<table id='CDR_ACC_Table_View'>
		</table>
	</div>
	</div>
	
<!-------------------------------------------------------------------------------------------------------- -->

<!-- CDR_MC_Table_Form ---------------------------------------------------------------------------------- -->

	<div class="g-hidden">
	<div class="box-modal" id="CDR_MC_Table_Form" mode="0">
		<div class="box-modal_name">MISSED CALLS</div>
		<div class="box-modal_close arcticmodal-close">close</div>
		<table id='CDR_MC_Table_View'>
		</table>
	</div>
	</div>
	
<!-------------------------------------------------------------------------------------------------------- -->




<br><br><br><br>
<!-- div class="block-fixed">
<div class="block-fixed-footer">
<table class="nb">
<tr>
<td colspan="2" style="vertical-align:bottom"><input type="button" class="inputbt" name="ConnectionApply" value=" Save " onclick="onSaveClick();doCDR_ACC_Find(1);"></td>
<td colspan="2" style="vertical-align:bottom"><input type="button" class="inputbt" name="ConnectionCancel" value=" Cancel " onclick="document.location.reload(true);"></td>
</tr>
</table>
</div>
</div -->


</form>

<?php require_once('../inc/common_footer.inc'); ?>
</body>
</html>


<?php
} else {
	print(LoginForm());
}
?>